
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Inventory_count_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const inventory_count_items = await db.inventory_count_items.create(
            {
                id: data.id || undefined,
        
        quantity_system: data.quantity_system
        ||
        null
            ,
            
        quantity_counted: data.quantity_counted
        ||
        null
            ,
            
        quantity_diff: data.quantity_diff
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await inventory_count_items.setInventory_count( data.inventory_count || null, {
            transaction,
        });
        
        await inventory_count_items.setProduct( data.product || null, {
            transaction,
        });
        
        await inventory_count_items.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return inventory_count_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const inventory_count_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                quantity_system: item.quantity_system
            ||
            null
            ,
            
                quantity_counted: item.quantity_counted
            ||
            null
            ,
            
                quantity_diff: item.quantity_diff
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const inventory_count_items = await db.inventory_count_items.bulkCreate(inventory_count_itemsData, { transaction });

        // For each item created, replace relation files
        

        return inventory_count_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const inventory_count_items = await db.inventory_count_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.quantity_system !== undefined) updatePayload.quantity_system = data.quantity_system;
        
        
        if (data.quantity_counted !== undefined) updatePayload.quantity_counted = data.quantity_counted;
        
        
        if (data.quantity_diff !== undefined) updatePayload.quantity_diff = data.quantity_diff;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await inventory_count_items.update(updatePayload, {transaction});

        
        
        if (data.inventory_count !== undefined) {
            await inventory_count_items.setInventory_count(
              
              data.inventory_count,
              
              { transaction }
            );
        }
        
        if (data.product !== undefined) {
            await inventory_count_items.setProduct(
              
              data.product,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await inventory_count_items.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return inventory_count_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const inventory_count_items = await db.inventory_count_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of inventory_count_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of inventory_count_items) {
                await record.destroy({transaction});
            }
        });


        return inventory_count_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const inventory_count_items = await db.inventory_count_items.findByPk(id, options);

        await inventory_count_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await inventory_count_items.destroy({
            transaction
        });

        return inventory_count_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const inventory_count_items = await db.inventory_count_items.findOne(
            { where },
            { transaction },
        );

        if (!inventory_count_items) {
            return inventory_count_items;
        }

        const output = inventory_count_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.inventory_count = await inventory_count_items.getInventory_count({
            transaction
        });
        
        
        output.product = await inventory_count_items.getProduct({
            transaction
        });
        
        
        output.organizations = await inventory_count_items.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.inventory_counts,
        as: 'inventory_count',
        
        where: filter.inventory_count ? {
          [Op.or]: [
            { id: { [Op.in]: filter.inventory_count.split('|').map(term => Utils.uuid(term)) } },
            {
              inventory_number: {
                [Op.or]: filter.inventory_count.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.products,
        as: 'product',
        
        where: filter.product ? {
          [Op.or]: [
            { id: { [Op.in]: filter.product.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.product.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'inventory_count_items',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.quantity_systemRange) {
                const [start, end] = filter.quantity_systemRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity_system: {
                    ...where.quantity_system,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity_system: {
                    ...where.quantity_system,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.quantity_countedRange) {
                const [start, end] = filter.quantity_countedRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity_counted: {
                    ...where.quantity_counted,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity_counted: {
                    ...where.quantity_counted,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.quantity_diffRange) {
                const [start, end] = filter.quantity_diffRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity_diff: {
                    ...where.quantity_diff,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity_diff: {
                    ...where.quantity_diff,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.inventory_count_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'inventory_count_items',
                        'notes',
                        query,
                    ),
                ],
            };
        }

        const records = await db.inventory_count_items.findAll({
            attributes: [ 'id', 'notes' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['notes', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.notes,
        }));
    }

    
};

